/*
Copyright (c) 2007, Sun Microsystems, Inc.
 
All rights reserved.
 
Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
 
 * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
 * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in
      the documentation and/or other materials provided with the
      distribution.
 * Neither the name of Sun Microsystems, Inc. nor the names of its
      contributors may be used to endorse or promote products derived
      from this software without specific prior written permission.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER
OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
//#include parameters.h
////////////////////////
// Compile params     //
////////////////////////



////////////////////////
// Game params        //
////////////////////////

////#define PING
////#define VIRTUAL_WORLD_MAP

////////////////////////
// Mobile Ajax params //
////////////////////////


////////////////////
// Logging params //
////////////////////

// enable to log in a mobile phone file (Nokia videos folder)
// we used the JSR75 
////#define LOG_FILE 


//#endinclude

//#ifdef GPS_BLUETOOTH
//# package org.ugasp.location;
//# 
//# import java.io.IOException;
//# import java.io.InputStream;
//# import java.util.Vector;
//# import javax.bluetooth.BluetoothStateException;
//# import javax.bluetooth.DeviceClass;
//# import javax.bluetooth.DiscoveryAgent;
//# import javax.bluetooth.DiscoveryListener;
//# import javax.bluetooth.LocalDevice;
//# import javax.bluetooth.RemoteDevice;
//# import javax.bluetooth.ServiceRecord;
//# import javax.bluetooth.UUID;
//# import javax.microedition.io.Connector;
//# import javax.microedition.io.StreamConnection;
//# import javax.microedition.lcdui.AlertType;
//# import javax.microedition.midlet.MIDlet;
//# 
//# import org.ugasp.demonstrator.client.IHMGasp;
//# 
//# /**
 //# *
 //# */
//# public class Discovery implements DiscoveryListener {
    //# 
    //# private static final UUID[] SPP_SET = { new UUID(0x1101) };
    //# 
    //# private LocalDevice localDevice = null;
    //# private DiscoveryAgent discoveryAgent = null;
    //# private Vector devices = new Vector();
    //# private Vector services = new Vector();
    //# private boolean deviceSearchInProgress = false;
    //# private boolean serviceSearchInProgress = false;
    //# private int serviceSearchId = 0;
    //# 
    //# private IHMGasp ihmGasp = null;
    //# private GPSInfo.Listener listener = null;
    //# 
    //# public Discovery(final IHMGasp ihmGasp) {
        //# this.ihmGasp = ihmGasp;
    //# }
        //# 
    //# public void performDiscovery() throws BluetoothStateException {
    	//#ifdef LOG_FILE
    	//# ResourcesManager.log("Discovery: performDiscovery ...");
    	//#endif LOG_FILE
    	//# localDevice = LocalDevice.getLocalDevice();
        //# 
        //# discoveryAgent = localDevice.getDiscoveryAgent();
        //# 
        //# retrieveDevices(DiscoveryAgent.CACHED);
        //# retrieveDevices(DiscoveryAgent.PREKNOWN);
        //# 
        //# deviceSearchInProgress = discoveryAgent.startInquiry(DiscoveryAgent.GIAC, this);
        //# ihmGasp.status(deviceSearchInProgress ? "searching" : "search failed");
    //# }
    //# 
    //# public void searchServices(final GPSInfo.Listener listener) throws BluetoothStateException, IOException {
        //# this.listener = listener;
        //# final RemoteDevice selectedDevice = findSelectedDevice();
        //# if (selectedDevice == null) {
            //# ihmGasp.status("no device selected");
            //# return;
        //# }
        //# 
        //#ifdef LOG_FILE
        //# ResourcesManager.log("Discovery searchServices...");
        //#endif LOG_FILE
        //# 
        //# for (int i=0; i < devices.size(); i++) {
            //# final RemoteDevice device = (RemoteDevice) devices.elementAt(i);
            //# final String friendlyName = device.getFriendlyName(false);
            //# 
            //#ifdef LOG_FILE
            //# ResourcesManager.log("Discovery searchServices: selected device:"+selectedDevice.getFriendlyName(false)+" ?= friendlyName: "+friendlyName );
            //#endif LOG_FILE
            //# 
            //# if (friendlyName.equals(selectedDevice.getFriendlyName(false))) {
                //# serviceSearchId = discoveryAgent.searchServices(null, SPP_SET, device, this);
                //# serviceSearchInProgress = true;
                //# 
                //#ifdef LOG_FILE
                //# ResourcesManager.log("Discovery searchServices: connecting to..." );
                //#endif LOG_FILE
                //# 
                //# ihmGasp.status("connecting to " + friendlyName + " ...");
            //# }
        //# }
    //# }
    //# 
    //# private void connect() throws BluetoothStateException, IOException {
        //# final RemoteDevice selectedDevice = findSelectedDevice();
        //# if (selectedDevice == null) {
        	//#ifdef LOG_FILE
        	//# ResourcesManager.log("Discovery connect: no device selected");
        	//#endif LOG_FILE
        	//# 
        	//# ihmGasp.status("no device selected");
            //# return;
        //# }
        //# 
        //# if (services.size() == 0) {
        	//#ifdef LOG_FILE
        	//# ResourcesManager.log("Discovery connect: no services found");
            //#endif LOG_FILE
        	//# 
        	//# ihmGasp.status("no services found");
            //# return;
        //# }
        //# 
        //# 
        //# for (int i=0; i < services.size(); i++) {
            //# final ServiceRecord sr = (ServiceRecord) services.elementAt(i);
        	//# 
            //#ifdef LOG_FILE
            //# ResourcesManager.log("GPSInfo constructor: connected to gps!");
            //#endif LOG_FILE
            //# 
        	//# if (sr.getHostDevice() == selectedDevice) {
        		//#ifdef LOG_FILE
        		//# ResourcesManager.log("Discovery connect: "+" service equal selected:"+sr);
        		//#endif LOG_FILE
        		//# 
                //# final String url = sr.getConnectionURL(ServiceRecord.NOAUTHENTICATE_NOENCRYPT, false);
                //# if (url != null) {
                	//#ifdef LOG_FILE
                	//# ResourcesManager.log("Discovery connect: "+"connecting to " + selectedDevice.getFriendlyName(false));
                	//#endif LOG_FILE
                	//# 
                	//# ihmGasp.status("connecting to " + selectedDevice.getFriendlyName(false));
                    //# final StreamConnection sconn = (StreamConnection) Connector.open(url);
                    //# ihmGasp.status("connected");
                    //# 
                    //#ifdef LOG_FILE
                    //# ResourcesManager.log("Discovery connect: connected to !");
                    //#endif LOG_FILE
                    //# 
                    //# final InputStream is = sconn.openInputStream();
                    //# 
                    //#ifdef LOG_FILE
                    //# ResourcesManager.log("Discovery connect: try to instantiate GPSInfo");
                    //#endif LOG_FILE
                    //# 
                    //# final GPSInfo gps = new GPSInfo(listener, is);
                    //# new Thread(gps).start();
                //# }
            //# }
        	//# 
        	//#ifdef LOG_FILE
        	//# ResourcesManager.log("Discovery connect: service not equal selected");
        	//#endif LOG_FILE
        //# }
    //# }
    //# 
    //# private void retrieveDevices(final int option) {
        //# final RemoteDevice[] remoteDevice = discoveryAgent.retrieveDevices(option);
        //# if (remoteDevice == null) {
            //# return;
        //# }
        //# for (int i=0; i < remoteDevice.length; i++) {
        	//#ifdef LOG_FILE
        	//# try {
        		//# 
				//# ResourcesManager.log("Discovery: device retrieved: "+remoteDevice[i].getFriendlyName(false));
			//# } catch (IOException e) {
				//# // TODO Auto-generated catch block
				//# e.printStackTrace();
			//# }
			//#endif LOG_FILE
            //# devices.addElement(remoteDevice[i]);
        //# }
    //# }
    //# 
    //# private static String getFriendlyName(final RemoteDevice remoteDevice) {
        //# String friendlyName = null;
        //# try {
            //# friendlyName = remoteDevice.getFriendlyName(false);
        //# } catch (IOException iex) {
            //# // fall-back to the address
            //# friendlyName = remoteDevice.getBluetoothAddress();
        //# }
        //# return friendlyName;
    //# }
    //# 
    //# public void deviceDiscovered(RemoteDevice remoteDevice, DeviceClass deviceClass) {
        //# final String friendlyName = getFriendlyName(remoteDevice);
        //# ihmGasp.status("found " + friendlyName);
        //# devices.addElement(remoteDevice);
        //# ihmGasp.get_deviceGroup().append(friendlyName, null);
    //# }
    //# 
    //# public void inquiryCompleted(int status) {
        //# deviceSearchInProgress = false;
        //# ihmGasp.status("done searching");
        //# if (devices.size() > 0) {
            //# ihmGasp.get_mainForm().addCommand(ihmGasp.get_connectCommand());
        //# }
    //# }
    //# 
    //# public void serviceSearchCompleted(int i, int i0) {
        //# serviceSearchInProgress = false;
        //# ihmGasp.status("done searching");
        //# try {
            //# connect();
        //# } catch (Exception ex) {
            //# ihmGasp.alert(AlertType.ERROR, "connect", ex);
        //# }
    //# }
    //# 
    //# public void servicesDiscovered(int i, ServiceRecord[] serviceRecord) {
        //# ihmGasp.status("found service");
        //# for (int j=0; j < serviceRecord.length; j++) {
            //# services.addElement(serviceRecord[j]);
        //# }
    //# }
    //# 
    //# private RemoteDevice findSelectedDevice() throws IOException {
        //# final int selectedIndex = ihmGasp.get_deviceGroup().getSelectedIndex();
        //# if (selectedIndex < 0) {
            //# ihmGasp.status("no device selected");
            //# return null;
        //# }
        //# final String selectedDeviceName = ihmGasp.get_deviceGroup().getString(selectedIndex);
        //# 
        //# for (int i=0; i < devices.size(); i++) {
            //# final RemoteDevice device = (RemoteDevice) devices.elementAt(i);
            //# final String friendlyName = device.getFriendlyName(false);
            //# if (selectedDeviceName.equals(friendlyName)) {
                //# return device;
            //# }
        //# }
        //# return null;
    //# }
//# }
//#endif GPS_BLUETOOTH
